##Author:wikii ?
##Date:20080302
##Version:v0.02
##Description:
##Usage for sutool:
##subdivideSelected 1 at vertices
##subdivideSelected 2 at midpoints
### TIG misc changes + menu 20091206 ###

require 'sketchup.rb'

def subdivideSelected(type=1)###
   def midpoint(ev)### better inside here
     pt=ev.collect{|x|Geom::Point3d.new x.position}
     rpt=Geom::Point3d.new
     pt.each{|x|rpt=rpt+Geom::Vector3d.new(x.x, x.y, x.z)}
     Geom::Point3d.linear_combination( 10, Geom::Point3d.new(0.mm,0.mm,0.mm), 1.0/ev.size,rpt)
   end
   ###
   Sketchup.active_model.start_operation("Subdivide Selected")###
   model = Sketchup.active_model
   ents=model.entities
   e_len=ents.length
   ss = model.selection
   pt_ar=[]

   if type==1#by vertex
      ss.each {|entity|
         ###if entity.typename == "Face"
         if entity.class == Sketchup::Face ### much faster
            evs = entity.vertices
            $ev=evs
            #cen = entity.bounds.center
            cen = midpoint(evs)
            evs.each {|vt|edge = model.active_entities.add_edges(cen,vt) }
         end
      }
   else#by midpoint
      ss.each {|entity|
         ###if entity.typename == "Face"
         if entity.class == Sketchup::Face ### much faster
            edges=entity.edges
            evs = entity.vertices
            #cen = entity.bounds.center
            cen = midpoint(evs)
            edges.each{|edge|
               pt_ar<<[ cen,  edge.bounds.center]
            }
         end
      }
      pt_ar.each{|x|  model.active_entities.add_edges x[0], x[1]}
   end
   Sketchup.active_model.commit_operation
   e_len.upto(ents.length-1){|x|ss.add ents[x]}
   #ents[e_len..-1].each{|x| ss.add x}
end#def

### Menu ###------------------------------------------------------------
if not file_loaded?(File.basename(__FILE__))
  submenu=UI.menu("Plugins").add_submenu("Subdivide Selected")
  submenu.add_item("At Vertices"){subdivideSelected(1);Sketchup.active_model.selection.clear}
  submenu.add_item("At Mid-Points"){subdivideSelected(2);Sketchup.active_model.selection.clear}
end#if
file_loaded(File.basename(__FILE__))
###
